using System;

namespace NUnit.Extensions.Converter
{
	public class PropertyConverter : SpecificObjectConverter
	{
		public PropertyConverter(Converter converter) : base(converter)
		{
		}
		protected override bool CanConvertSelf(object o)
		{
			return o is Property;
		}
		protected override object ConvertSelf(object o)
		{
			Property property = (Property)o;
			string name = DelegateToString(property.Name);
			if (Converter.NotVisible(name))
				return Converter.INVISIBLE;
			string value = DelegateToString(property.Value);
			if (Converter.NotVisible(value))
				return Converter.INVISIBLE;
			return name + "=" + value;
		}
	}
}
