using System;
using System.Collections;

namespace NUnit.Extensions.Converter
{
	public class Sorter
	{
		private Converter converter;
		public Sorter(Converter converter)
		{
			this.converter = converter;
		}
		private class Comparer : IComparer
		{
			private Converter converter;
			public Comparer(Converter converter)
			{
				this.converter = converter;
			}
			public int Compare(object o1, object o2) 
			{
				return converter.ToString(o1).CompareTo(converter.ToString(o2));
			}
		}
		public IList Sort(ICollection collection) 
		{
			ArrayList list = new ArrayList(collection);
			list.Sort(new Comparer(converter));
			return list;
		}
		public object Sort(object o)
		{
			ICollection c = o as ICollection;
			if (c != null)
				return Sort(c);
			return o;
		}
	}
}
